#include "stm32f10x.h"                  // Device header
#include "Serial.h"
#include "PWM.h"
#include "Delay.h"

#include <stdlib.h>

void pin_Init(void)
{
	/*ʱ*/
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);	
	//RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);					
	GPIO_InitTypeDef GPIO_InitStructure;					
	
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;		
	GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_6|GPIO_Pin_7|GPIO_Pin_8|GPIO_Pin_9|GPIO_Pin_10|GPIO_Pin_11|GPIO_Pin_12|GPIO_Pin_13;				
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;		
	
		
	
	GPIO_InitTypeDef GPIO_InitStructureIn;
	GPIO_InitStructureIn.GPIO_Mode = GPIO_Mode_IPU;
	GPIO_InitStructureIn.GPIO_Pin = GPIO_Pin_3|GPIO_Pin_4|GPIO_Pin_14|GPIO_Pin_15;
	GPIO_InitStructureIn.GPIO_Speed = GPIO_Speed_50MHz;
	
	
	GPIO_Init(GPIOB, &GPIO_InitStructure);
	GPIO_Init(GPIOB, &GPIO_InitStructureIn);	
									
}

int pinBSet(int pinx,int Setpin)
{
	
	if(Setpin==0 )
	{
		switch(pinx)
		{
			case 6:
				GPIO_WriteBit(GPIOB, GPIO_Pin_6, Bit_RESET);//
				//Serial_SendString("B10:LOW");
				break;
			case 7:
				GPIO_WriteBit(GPIOB, GPIO_Pin_7, Bit_RESET);//ˮǹ
				break;
			case 8:
				GPIO_WriteBit(GPIOB, GPIO_Pin_8, Bit_RESET);//
				//Serial_SendString("B10:LOW");
				break;
			case 9:
				GPIO_WriteBit(GPIOB, GPIO_Pin_9, Bit_RESET);//ˮǹ
				//Serial_SendString("B10:LOW");
				break;
			case 10:
				GPIO_WriteBit(GPIOB, GPIO_Pin_10, Bit_RESET);
				//Serial_SendString("B10:LOW");
				break;
			case 11:
				GPIO_WriteBit(GPIOB, GPIO_Pin_11, Bit_RESET);
				//Serial_SendString("B11:LOW");
				break;
			case 12:
				GPIO_WriteBit(GPIOB, GPIO_Pin_12, Bit_RESET);
				//Serial_SendString("B12:LOW");
				break;
			case 13:
				GPIO_WriteBit(GPIOB, GPIO_Pin_13, Bit_RESET);
				//Serial_SendString("B13:LOW");
				break;
			default:
				break;
		}
		
	}
	
	if(Setpin==1 )
	{
		switch(pinx)
		{
			case 6:
				GPIO_WriteBit(GPIOB, GPIO_Pin_6, Bit_SET);//
				//Serial_SendString("B10:HIGH");
				break;
			case 7:
				GPIO_WriteBit(GPIOB, GPIO_Pin_7, Bit_SET);//ˮǹ
				//Serial_SendString("B10:HIGH");
				break;
			case 8:
				GPIO_WriteBit(GPIOB, GPIO_Pin_8, Bit_SET);//
				//Serial_SendString("B10:HIGH");
				break;
			case 9:
				GPIO_WriteBit(GPIOB, GPIO_Pin_9, Bit_SET);//ˮǹ
				//Serial_SendString("B10:HIGH");
				break;
			case 10:
				GPIO_WriteBit(GPIOB, GPIO_Pin_10, Bit_SET);
				//Serial_SendString("B10:HIGH");
				break;
			case 11:
				GPIO_WriteBit(GPIOB, GPIO_Pin_11, Bit_SET);
				//Serial_SendString("B11:HIGH");
				break;
			case 12:
				GPIO_WriteBit(GPIOB, GPIO_Pin_12, Bit_SET);
				//Serial_SendString("B12:HIGH");
				break;
			case 13:
				GPIO_WriteBit(GPIOB, GPIO_Pin_13, Bit_SET);
				//Serial_SendString("B13:HIGH");
				break;
			default:
				break;
		}
		
	}
	return pinx;
}

int Read_Apin(void)
{
	if(GPIO_ReadInputDataBit(GPIOB, GPIO_Pin_3)==0)
	{
		
		return 1;
		
	}
	if(GPIO_ReadInputDataBit(GPIOB, GPIO_Pin_4)==0)
	{
		
		return 2;
		
	}
	if(GPIO_ReadInputDataBit(GPIOB, GPIO_Pin_14)==0)
	{
		
		return 3;
	}
	if(GPIO_ReadInputDataBit(GPIOB, GPIO_Pin_15)==0)
	{
		
		return 4;
	}
	return 0;
}



void right_pwm(uint8_t gval)
{
	if(gval<=45)
	{
		PWM_SetCompare2(145);
		//vTaskDelay(pdMS_TO_TICKS(10));
		PWM_SetCompare2(138);
	}
	if(gval>45&&gval<=51)
	{
		PWM_SetCompare2(105);
	}
	if(gval>51&&gval<=57)
	{
		PWM_SetCompare2(95);
	}
	if(gval>57&&gval<=63)
	{
		PWM_SetCompare2(90);
	}
	if(gval>63&&gval<=69)
	{
		PWM_SetCompare2(90);
	}
	if(gval>69&&gval<=75)
	{
		PWM_SetCompare2(85);
	}
	
}

void left_pwm(uint8_t gval)
{
	if(gval<=45)
	{
		//PWM_SetCompare2(133);
		//Delay_ms(15);
		//vTaskDelay(pdMS_TO_TICKS(10));
		PWM_SetCompare2(138);
	}
	if(gval>45&&gval<=51)
	{
		PWM_SetCompare2(165);
	}
	if(gval>51&&gval<=57)
	{
		PWM_SetCompare2(175);
	}
	if(gval>57&&gval<=63)
	{
		PWM_SetCompare2(180);
	}
	if(gval>63&&gval<=69)
	{
		PWM_SetCompare2(180);
	}
	if(gval>69&&gval<=75)
	{
		PWM_SetCompare2(185);
	}
	
}

void back_MN(uint8_t gval)
{
//	PWM_SetCompare1(120);
//			Delay_ms(12);
//	PWM_SetCompare1(170-gval);
//		Delay_ms(12);
//	PWM_SetCompare1(120);
//		Delay_ms(12);
//	PWM_SetCompare1(170-gval);
	if(gval<=50)
	{
		PWM_SetCompare1(150);
	}
	if(50<gval&&gval<=55)
	{
		PWM_SetCompare1(145); 
	}
	if(55<gval&&gval<=60)
	{
		PWM_SetCompare1(140);
	}
	if(60<gval&&gval<=65)
	{
		PWM_SetCompare1(138);
	}
	if(65<gval&&gval<=70)
	{ 
		PWM_SetCompare1(135);
	}
	if(70<gval&&gval<=75)
	{
		PWM_SetCompare1(130);
	}
	if(75<gval&&gval<=85)
	{
		PWM_SetCompare1(128);
	}
	if(85<gval&&gval<=100)
	{
		PWM_SetCompare1(125);
	}		
}

void flont_MN(uint8_t gval)
{

	if(gval<=50)
	{
		PWM_SetCompare1(150);
	}
	if(50<gval&&gval<=55)
	{
		PWM_SetCompare1(155);
	}
	if(55<gval&&gval<=60)
	{
		PWM_SetCompare1(158);
	}
	if(60<gval&&gval<=65)
	{
		PWM_SetCompare1(165);
	}
	if(65<gval&&gval<=70)
	{
		PWM_SetCompare1(170);
	}
	if(70<gval&&gval<=75)
	{
		PWM_SetCompare1(174);
	}
	if(75<gval&&gval<=90)
	{
		PWM_SetCompare1(180);
	}
	if(90<gval&&gval<=100)
	{
		PWM_SetCompare1(185);
	}
		
	
}

void mn_control(uint8_t gmode,uint8_t gval)
{
	switch(gmode)
	{
		case 1:			
		flont_MN(gval);					 
			break;
		case 2:	
			back_MN(gval);
			break;
		case 3:
			left_pwm(gval);
			break;
		case 4:
			right_pwm(gval);
			break;
		case 5:
			 PWM_control(5,gval);
			break;
		case 6:
			PWM_control(6,gval);
			break;
		case 7:
			PWM_control(8,gval);
			break;
		case 8:
			PWM_control(8,gval);
			break;
		default:
			break;
	}
		
}
